/*=========================================================================
 
Program:   Medical Imaging & Interaction Toolkit
Language:  C++
Date:      $Date: 2010-03-31 16:40:27 +0200 (Wed, 31 Mar 2010) $
Version:   $Revision: 1.12 $
 
Copyright (c) German Cancer Research Center, Division of Medical and
Biological Informatics. All rights reserved.
See MITKCopyright.txt or http://www.mitk.org/copyright.html for details.
 
This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notices for more information.
 
=========================================================================*/

#ifndef QmitkSegmentationView_h
#define QmitkSegmentationView_h

#include "QmitkFunctionality.h"

#include "ui_QmitkSegmentationViewControls.h"

class QmitkRenderWindow;
class QmitkSegmentationPostProcessing;


class QmitkSegmentationView : public QObject, public QmitkFunctionality
{
  Q_OBJECT

  public:

    QmitkSegmentationView();
    virtual ~QmitkSegmentationView();


  protected:
    
    // GUI setup
    void CreateQtPartControl(QWidget* parent);

    // the Qt parent of our GUI (NOT of this object)
    QWidget* m_Parent;

    // our GUI
    Ui::QmitkSegmentationControls * m_Controls;
};

#endif /*QMITKsegmentationVIEW_H_*/

