@echo off
echo WARNING: cmake is stupid and does not like spaces in file/directory names. 
echo          Avoid placing the source and build directories in to a directory (path) with spaces.


REM ------------- Configuration options --------------


call "L:\Program Files\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"

REM add path to nmake, cmake, devenv, etc.
@set PATH=L:\Program Files\Microsoft Visual Studio 9.0\VC\bin;%PATH%
@set PATH=L:\Program Files\Microsoft Visual Studio 9.0\Common7\IDE;%PATH%
@set PATH=C:\CMake_2.8\bin;%PATH%
@set PATH=C:\Qt\4.6.3\bin;%PATH%

@SET CMAKE_EXE=cmake
@SET QMAKE_EXE=C:\Qt\4.6.3\bin\qmake

@SET BUILDTYPE=Debug
REM @SET BUILDTYPE=Release
REM @SET BUILDTYPE=RelWithDebInfo

REM uncomment this if you want to create visual studio projects
@SET USEVC="foo"

if defined USEVC goto else
@SET GENERATOR="NMake Makefiles"
@SET BUILD_VTK=nmake
@SET BUILD_ITK=nmake
@SET BUILD_MITK=nmake
goto endif
:else
REM else use visual studio (creates a visual studio project)
@SET GENERATOR="Visual Studio 9 2008"
@SET BUILD_VTK=devenv VTK.sln /build %BUILDTYPE%
@SET BUILD_ITK=devenv ITK.sln /build %BUILDTYPE%
@SET BUILD_MITK=devenv MITK.sln /build %BUILDTYPE%
@SET BUILD_MITKPlugins=devenv ModelGeneration.sln /build %BUILDTYPE%
:endif


echo  
echo %GENERATOR%
echo %BUILD_VTK%
echo %BUILD_ITK%
echo %BUILD_MITK%
echo  


REM ----------- Set variables ---------------------

@SET TOP_DIR="%CD%"

@SET VTK_SRC="%CD%\VTK"
@SET ITK_SRC="%CD%\ITK"
@SET MITK_SRC="%CD%\MITK"
@SET MITKPlugins_SRC="%CD%\mitkplugins\src"

@SET ITK_DIR="%CD%\Build\ITK"
@SET VTK_DIR="%CD%\Build\VTK"
@SET MITK_DIR="%CD%\Build\MITK"
@SET MITKPlugins_DIR="%CD%\Build\mitkplugins"





REM ----------- SETup configuration ---------------

REM Create Build Directories

mkdir Build
mkdir %ITK_DIR%
mkdir %VTK_DIR%
mkdir %MITK_DIR%
mkdir %MITKPlugins_DIR%




cd %VTK_DIR%
%CMAKE_EXE% -DCMAKE_BUILD_TYPE=%BUILDTYPE% -DBUILD_SHARED_LIBS=ON -DBUILD_EXAMPLES=OFF -DBUILD_TESTING=OFF -DVTK_USE_RPATH=ON -DVTK_USE_PARALLEL=ON -DVTK_USE_HYBRID=ON -DBUILD_SHARED_LIBS=ON -DVTK_USE_GUISUPPORT=ON -DDESIRED_QT_VERSION=4 -DVTK_USE_QVTK=ON -DVTK_USE_QVTK_QTOPENGL=ON -DVTK_USE_GEOVIS=OFF -DVTK_USE_INFOVIS=OFF -DQT_QMAKE_EXECUTABLE=%QMAKE_EXE% %VTK_SRC% -G %GENERATOR%
%BUILD_VTK%
cd %TOP_DIR%




cd %ITK_DIR%
%CMAKE_EXE% -DCMAKE_BUILD_TYPE=%BUILDTYPE% -DBUILD_SHARED_LIBS=ON -DCMP0010=OLD -DBUILD_EXAMPLES=OFF -DBUILD_TESTING=OFF %ITK_SRC% -G %GENERATOR%
%BUILD_ITK%
cd %TOP_DIR%



REM add some more paths needed for MITK

@set OSGI_RUNTIME=%MITK_DIR%\bin\openCherry\org.opencherry.osgi
@set PATH=%ITK_DIR%\bin\%BUILDTYPE%;%OSGI_RUNTIME%\bin\%BUILDTYPE%;%VTK_DIR%\bin\%BUILDTYPE%;%PATH%

REM convert windows paths to cmake convention, this is not needed if you configure 
REM mitk via the cmake gui. However, for some stupid reason, the backslash is interpreted 
REM as an escape sequence when calling FIND_PACKAGE(ITK) in MITK. 

@set ITK_DIR_CMAKE=%ITK_DIR:\=/%
@set VTK_DIR_CMAKE=%VTK_DIR:\=/%

REM call cmake twice; for some reason it fails on first run and succeeds afterwards
cd %MITK_DIR%
%CMAKE_EXE% -DCMAKE_BUILD_TYPE=%BUILDTYPE% -DQT_QMAKE_EXECUTABLE=%QMAKE_EXE% -DVTK_DIR=%VTK_DIR_CMAKE% -DITK_DIR=%ITK_DIR_CMAKE% -DUSE_ITKZLIB=ON %MITK_SRC% -G %GENERATOR%
%CMAKE_EXE% -DCMAKE_BUILD_TYPE=%BUILDTYPE% -DQT_QMAKE_EXECUTABLE=%QMAKE_EXE% -DVTK_DIR=%VTK_DIR_CMAKE% -DITK_DIR=%ITK_DIR_CMAKE% -DUSE_ITKZLIB=ON %MITK_SRC% -G %GENERATOR%
%BUILD_MITK%
cd %TOP_DIR%



REM not tested this part yet, should work

@set MITK_DIR_CMAKE=%MITK_DIR:\=/%

cd %MITKPlugins_DIR%
%CMAKE_EXE% -DCMAKE_BUILD_TYPE=%BUILDTYPE% -DMITK_DIR=%MITK_DIR_CMAKE% %MITKPlugins_SRC% -G %GENERATOR%
REM %BUILD_MITKPlugins%
cd %TOP_DIR%

:endoffile
